# Copyright (C) 2018-present MongoDB, Inc.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the Server Side Public License, version 1,
# as published by MongoDB, Inc.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# Server Side Public License for more details.
#
# You should have received a copy of the Server Side Public License
# along with this program. If not, see
# <http://www.mongodb.com/licensing/server-side-public-license>.
#
# As a special exception, the copyright holders give permission to link the
# code of portions of this program with the OpenSSL library under certain
# conditions as described in each individual source file and distribute
# linked combinations including the program with the OpenSSL library. You
# must comply with the Server Side Public License in all respects for
# all of the code used other than as permitted herein. If you modify file(s)
# with this exception, you may extend this exception to your version of the
# file(s), but you are not obligated to do so. If you do not wish to do so,
# delete this exception statement from your version. If you delete this
# exception statement from all source files in the program, then also delete
# it in the license file.
#
global:
    cpp_namespace: "mongo"
    cpp_includes:
    - "mongo/db/commands/create_command_validation.h"

imports:
    - "mongo/db/auth/action_type.idl"
    - "mongo/db/auth/access_checks.idl"
    - "mongo/db/basic_types.idl"
    - "mongo/db/catalog/collection_options.idl"
    - "mongo/db/timeseries/timeseries.idl"
    - "mongo/db/pipeline/change_stream_pre_and_post_images_options.idl"

structs:
    CollModIndex:
        description: "A type representing a spec for an index to be modified by collMod command."
        strict: true
        fields:
            name:
                optional: true
                type: string
                stability: stable
            keyPattern:
                optional: true
                type: object
                stability: stable
            expireAfterSeconds:
                optional: true
                type: safeInt
                stability: stable
            hidden:
                optional: true
                type: safeBool
                stability: stable
            unique:
                optional: true
                type: safeBool
                stability: unstable
            prepareUnique:
                optional: true
                type: safeBool
                stability: unstable
            forceNonUnique:
                optional: true
                type: safeBool
                stability: unstable

    CollModReply:
        description: "The collMod command's reply."
        strict: true
        is_command_reply: true
        fields:
            expireAfterSeconds_old:
                optional: true
                type: safeInt
                stability: stable
            expireAfterSeconds_new:
                optional: true
                type: safeInt
                stability: stable
            hidden_old:
                optional: true
                type: safeBool
                stability: stable
            hidden_new:
                optional: true
                type: safeBool
                stability: stable
            unique_new:
                optional: true
                type: safeBool
                stability: unstable
            prepareUnique_old:
                optional: true
                type: safeBool
                stability: unstable
            prepareUnique_new:
                optional: true
                type: safeBool
                stability: unstable
            forceNonUnique_new:
                optional: true
                type: safeBool
                stability: unstable

    CollModRequest:
        description: "The collMod command's request."
        strict: true
        fields:
            index:
                description: "Index to be modified."
                optional: true
                type: CollModIndex
                stability: stable
            validator:
                description: "Specify validation rules or expressions for the collection."
                type: object
                optional: true
                stability: stable
            validationLevel:
                description: "Determines how strictly to apply the validation rules to existing
                              documents during an update.
                              Can be one of following values: 'off', 'strict' or 'moderate'."
                type: ValidationLevel
                optional: true
                stability: stable
            validationAction:
                description: "Determines whether to error on invalid documents or just warn about
                              the violations but allow invalid documents to be inserted.
                              Can be either 'warn' or 'error'."
                type: ValidationAction
                optional: true
                stability: stable
            viewOn:
                description: "The name of the source collection or view that
                              'namespace' is based off of."
                type: string
                optional: true
                stability: stable
                validator:
                    callback: create_command_validation::validateViewOnNotEmpty
            pipeline:
                description: "An array that consists of the aggregation pipeline. Defines the view
                              by applying the specified pipeline to the 'viewOn' collection or
                              view."
                type: array<object>
                optional: true
                stability: stable
            changeStreamPreAndPostImages:
                description: "The options for point-in-time pre- and post-images in change streams opened on this collection."
                type: ChangeStreamPreAndPostImagesOptions
                optional: true
                stability: unstable
            expireAfterSeconds:
                description: "The number of seconds after which old data should be deleted. This can
                              be disabled by passing in 'off' as a value"
                optional: true
                stability: stable
                type:
                    variant: [string, safeInt64]
            timeseries:
                description: "Adjusts parameters for timeseries collections"
                optional: true
                type: CollModTimeseries
                stability: stable
            timeseriesBucketsMayHaveMixedSchemaData:
                description: >-
                    Whether the time-series collection may have mixed schema data, which was only
                    possible to write in FCV 5.1 and earlier.
                optional: true
                type: safeBool
                stability: unstable
            dryRun:
                description: "Runs the requested modification without modifying any database state.
                              This can be used to determine in advance if a particular collMod
                              request can be completed without errors."
                optional: true
                type: safeBool
                stability: unstable
            collectionUUID:
                description: "The expected UUID of the collection."
                type: uuid
                optional: true
                stability: unstable
            cappedSize:
                description: "Update the maximum size in bytes for the capped collection."
                type: safeInt64
                optional: true
                validator:
                    gte: 1
                    lte: 1125899906842624  # 1 PB
                stability: stable
            cappedMax:
                description: "Update the maximum number of documents allowed in the capped collection."
                type: safeInt64
                optional: true
                validator:
                    lt: 2147483648  # 2^31
                stability: stable

commands:
    collMod:
        description: "Specify collMod Command."
        command_name: collMod
        namespace: concatenate_with_db
        cpp_name: collMod
        strict: true
        api_version: "1"
        access_check:
            complex:
                - check: should_ignore_auth_checks
                - privilege:
                    resource_pattern: exact_namespace
                    action_type: collMod
                - privilege:
                    resource_pattern: exact_namespace
                    action_type: find
        inline_chained_structs: true
        chained_structs:
            CollModRequest: CollModRequest
        reply_type: CollModReply
